clear all
set more off
set linesize 80
set scheme sj

sysuse auto
describe

list make mpg

list make mpg in 1/5

list make mpg in 20/25

list make mpg if foreign == 1

list make mpg in 1/10 if mpg < 20

generate mpg20 = 0
replace mpg20 = 1 if mpg > 20

generate mpgnew = 1 if mpg < 20
replace mpgnew = 2 if mpg >= 20 & mpg <= 30
replace mpgnew = 3 if mpg > 30

generate mpg20new = mpg > 20

egen meanmpg = mean(mpg)

by foreign: egen groupmpg = mean(mpg)


summarize mpg

summarize mpg price weight

summarize mpg, detail

summarize mpg if foreign == 1

by foreign: summarize mpg

table foreign

table foreign mpg20

tabulate foreign 

tabulate foreign mpg20

table foreign, contents(n weight mean weight sd weight)

replace mpg = . in 1
list mpg in 1/5

generate mpg20a = 1 if mpg > 20
list mpg mpg20a in 1/5

generate mpg20b = 1 if mpg > 20 & mpg < .
list mpg mpg20a mpg20b in 1/5

histogram mpg, title("Distribution of miles per gallon") normal scheme(lean2)


graph box mpg, by(foreign, title("Miles per gallon for foreign and domestic cars")) ///
scheme(lean2)

twoway scatter mpg weight, title("Relationship between MPG and weight") ///
scheme(lean2)

twoway (scatter mpg weight if foreign == 1) ///
(scatter mpg weight if foreign == 0), ///
legend(label(1 "Foreign") label(2 "Domestic")) ///
title("Relationship between MPG and weight") scheme(lean2)




ssc install metan, replace

label variable mpg "Miles per gallon"

label define mpgvalues 1 "Greater than 20" 0 "20 or less"

label values mpg20 mpgvalues


sysuse auto, clear
summarize mpg
