clear all
set more off
set linesize 80

use trait
describe


summarize trait2-trait20, separator(0)

corr trait2-trait20

display  0.4553^2


corr trait2-trait20
matrix corr = r(C)
matrix sqcorr = J(7,7,0)
forvalues i = 1/7 {
	forvalues j = 1/7 {
		matrix sqcorr[`i', `j'] = corr[`i', `j']^2
	}
}
matrix list sqcorr



corr trait2-trait20, covariance

sem (TRAIT_ANX -> trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
var(TRAIT_ANX@1) nolog nocnsreport
estat framework, fitted

estat gof


sem (TRAIT_ANX -> trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
var(TRAIT_ANX@1) nolog nocnsreport coeflegend

display _b[trait2:TRAIT_ANX]^2 + _b[/var(e.trait2)]
display _b[trait4:TRAIT_ANX]^2 + _b[/var(e.trait4)]
display _b[trait5:TRAIT_ANX]^2 + _b[/var(e.trait5)]
display _b[trait8:TRAIT_ANX]^2 + _b[/var(e.trait8)]
display _b[trait9:TRAIT_ANX]^2 + _b[/var(e.trait9)]
display _b[trait15:TRAIT_ANX]^2 + _b[/var(e.trait15)]
display _b[trait20:TRAIT_ANX]^2 + _b[/var(e.trait20)]

tabstat trait2-trait20, stat(var)

*** This may seem like it is good enough for government work
*** And you'd be right. But why don't they equal the same thing
*** nm1 option. 
*** nm1 specifies that the variances and covariances used in the SEM equations be the sample variances(divided by N - 1) and not the asymptotic variances (divided by N). This is a minor technicalissue of little importance unless you are trying to match results from other software that assumes sample variances. sem assumes asymptotic variances.


sem (TRAIT_ANX -> trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
var(TRAIT_ANX@1) nolog nocnsreport nm1

display _b[trait2:TRAIT_ANX]^2 + _b[/var(e.trait2)]
display _b[trait4:TRAIT_ANX]^2 + _b[/var(e.trait4)]
display _b[trait5:TRAIT_ANX]^2 + _b[/var(e.trait5)]
display _b[trait8:TRAIT_ANX]^2 + _b[/var(e.trait8)]
display _b[trait9:TRAIT_ANX]^2 + _b[/var(e.trait9)]
display _b[trait15:TRAIT_ANX]^2 + _b[/var(e.trait15)]
display _b[trait20:TRAIT_ANX]^2 + _b[/var(e.trait20)]




display .5038255^2 + .315201


/*

matrix sighat = r(Sigma)
matrix list sighat
matrix sighat = sighat[1..7,1..7]
matrix list sighat

corr trait2-trait20, covariance
matrix sigma = r(C)

*** see pdf in directory -- goodnessofFit.pdf

matrix t1 = trace(invsym(sighat)*sigma)
matrix t2 = ln(det(invsym(sighat)*sigma))
matrix t3 = 7

matrix t4 = 790*(t1 - t2 - t3)
matrix list t4

scalar p = 7
display (p*(p+1))/2 // unique information
** 14 parameters, thus 14 degrees of freedom

*/


estat framework, fitted


sem (TRAIT_ANX -> trait2@l trait4@l trait5@l trait8@l ///
trait9@l trait15@l trait20@l) ///
(trait2 trait4 trait5 trait8 trait15 trait20 <- _cons@m), ///
var(TRAIT_ANX@1) ///
covstructure(e.trait2 e.trait4 e.trait5 e.trait8 ///
e.trait15 e.trait20, identity) ///
nolog nocnsreport

sem (TRAIT_ANX -> trait2@l trait4@l trait5@l trait8@l ///
trait9@l trait15@l trait20@l), ///
var(TRAIT_ANX@1) ///
covstructure(e.trait2 e.trait4 e.trait5 e.trait8 ///
e.trait9 e.trait15 e.trait20, identity) ///
nolog nocnsreport
estimates store parallel

sem (TRAIT_ANX -> trait2@l1 trait4@l1 trait5@l1 trait8@l1 ///
trait9@l1 trait15@l1 trait20@l1), ///
var(TRAIT_ANX@1) ///
nolog nocnsreport



sem (TRAIT_ANX -> trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
var(TRAIT_ANX@1) nolog 

		
nlcom omega:(_b[trait2:TRAIT_ANX] + _b[trait4:TRAIT_ANX] + ///
_b[trait5:TRAIT_ANX] + _b[trait8:TRAIT_ANX] + ///
_b[trait9:TRAIT_ANX] + _b[trait15:TRAIT_ANX] + ///
_b[trait20:TRAIT_ANX])^2 *_b[/var(TRAIT_ANX)] / ((_b[trait2:TRAIT_ANX] + _b[trait4:TRAIT_ANX] + ///
_b[trait5:TRAIT_ANX] + _b[trait8:TRAIT_ANX] + ///
_b[trait9:TRAIT_ANX] + _b[trait15:TRAIT_ANX] + ///
_b[trait20:TRAIT_ANX])^2 *_b[/var(TRAIT_ANX)] + (_b[/var(e.trait2)] + ///
_b[/var(e.trait4)] + _b[/var(e.trait5)] + ///
_b[/var(e.trait8)] + _b[/var(e.trait9)] + ///
_b[/var(e.trait15)] + _b[/var(e.trait20)])), noheader






sem (TRAIT_ANX -> trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
var(TRAIT_ANX@1) nolog nocnsreport

estat eqgof

display (.504^2)*1/((.504^2)*1 + .315)

tabstat trait2-trait20, stat(var)

sem (TRAIT_ANX -> trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
var(TRAIT_ANX@1) nolog nocnsreport nm1

sem (TRAIT_ANX -> trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
var(TRAIT_ANX@1) nolog nocnsreport coeflegend


sem (TRAIT_ANX -> trait2* trait4 trait5 trait8 ///
				  trait9 trait15 trait20), ///
    var(TRAIT_ANX@1) nolog nocnsreport 

nlcom (sig2_common:(_b[trait2:TRAIT_ANX] + _b[trait4:TRAIT_ANX] + ///
_b[trait5:TRAIT_ANX] + _b[trait8:TRAIT_ANX] + ///
_b[trait9:TRAIT_ANX] + _b[trait15:TRAIT_ANX] + ///
_b[trait20:TRAIT_ANX])^2*_b[/var(TRAIT_ANX)]), noheader	

nlcom (sig2_unique:(_b[/var(e.trait2)] + ///
_b[/var(e.trait4)] + _b[/var(e.trait5)] + ///
_b[/var(e.trait8)] + _b[/var(e.trait9)] + ///
_b[/var(e.trait15)] + _b[/var(e.trait20)])), noheader	


capture program drop relboot
program relboot, rclass
version 15.1
sem (TRAIT_ANX -> trait2* trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
var(TRAIT_ANX@1) nolog nocnsreport
nlcom (_b[trait2:TRAIT_ANX] + _b[trait4:TRAIT_ANX] + ///
_b[trait5:TRAIT_ANX] + _b[trait8:TRAIT_ANX] + ///
_b[trait9:TRAIT_ANX] + _b[trait15:TRAIT_ANX] + ///
_b[trait20:TRAIT_ANX])^2 *_b[/var(TRAIT_ANX)] / ((_b[trait2:TRAIT_ANX] + _b[trait4:TRAIT_ANX] + ///
_b[trait5:TRAIT_ANX] + _b[trait8:TRAIT_ANX] + ///
_b[trait9:TRAIT_ANX] + _b[trait15:TRAIT_ANX] + ///
_b[trait20:TRAIT_ANX])^2 *_b[/var(TRAIT_ANX)] + (_b[/var(e.trait2)] + ///
_b[/var(e.trait4)] + _b[/var(e.trait5)] + ///
_b[/var(e.trait8)] + _b[/var(e.trait9)] + ///
_b[/var(e.trait15)] + _b[/var(e.trait20)]))
return scalar reliab = el(r(b), 1, 1)
end


bootstrap r(reliab), reps(1000) seed(45639) nodots: relboot
estat bootstrap, percentile



sem (TRAIT_ANX -> trait2@a trait4@a trait5@a trait8@a ///
trait9@a trait15@a trait20@a), ///
var(TRAIT_ANX@1) nolog nocnsreport
nlcom (omega_tau: (_b[trait2:TRAIT_ANX] + _b[trait4:TRAIT_ANX] + ///
_b[trait5:TRAIT_ANX] + _b[trait8:TRAIT_ANX] + ///
_b[trait9:TRAIT_ANX] + _b[trait15:TRAIT_ANX] + ///
_b[trait20:TRAIT_ANX])^2 *_b[/var(TRAIT_ANX)] / ((_b[trait2:TRAIT_ANX] + _b[trait4:TRAIT_ANX] + ///
_b[trait5:TRAIT_ANX] + _b[trait8:TRAIT_ANX] + ///
_b[trait9:TRAIT_ANX] + _b[trait15:TRAIT_ANX] + ///
_b[trait20:TRAIT_ANX])^2 *_b[/var(TRAIT_ANX)] + (_b[/var(e.trait2)] + ///
_b[/var(e.trait4)] + _b[/var(e.trait5)] + ///
_b[/var(e.trait8)] + _b[/var(e.trait9)] + ///
_b[/var(e.trait15)] + _b[/var(e.trait20)]))), noheader


nlcom (7^2*(_b[trait2:TRAIT_ANX])^2)/((7^2*(_b[trait2:TRAIT_ANX])^2) + (_b[/var(e.trait2)] + ///
_b[/var(e.trait4)] + _b[/var(e.trait5)] + ///
_b[/var(e.trait8)] + _b[/var(e.trait9)] + ///
_b[/var(e.trait15)] + _b[/var(e.trait20)]))

alpha trait2-trait20





*** producing chi2 test

quietly sem (TRAIT_ANX -> trait2@l1 trait4@l1 trait5@l1 trait8@l1 ///
trait9@l1 trait15@l1 trait20@l1), ///
var(TRAIT_ANX@1) ///
nolog nocnsreport
estimates store tauequiv
scalar nested_chi2 = e(chi2_ms)
scalar nested_df = e(df_ms)

quietly sem (TRAIT_ANX -> trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
var(TRAIT_ANX@1) nolog
estimates store congeneric
scalar parent_chi2 = e(chi2_ms)
scalar parent_df = e(df_ms)
display nested_chi2
display nested_df
display parent_chi2
display parent_df
display 1 - chi2(nested_df - parent_df, nested_chi2 - parent_chi2)

lrtest tauequiv congeneric


sem (TRAIT_ANX -> trait2@l1 trait4@l1 trait5@l1 trait8@l1 ///
trait9@l1 trait15@l1 trait20@l1), ///
var(TRAIT_ANX@1) ///
covstructure(e.trait2 e.trait4 e.trait5 e.trait8 ///
e.trait9 e.trait15 e.trait20, identity) ///
nolog nocnsreport
estimates store parallel


lrtest tauequiv parallel



sem (TRAIT_ANX -> trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
var(TRAIT_ANX@1) cov(e.trait5*e.trait15) nolog
estimates store corr_error

lrtest congeneric corr_error

sem (TRAIT_ANX -> trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
var(TRAIT_ANX@1) cov(e.trait5*e.trait15) nolog coeflegend

nlcom omega_corr:(_b[trait2:TRAIT_ANX] + _b[trait4:TRAIT_ANX] + ///
_b[trait5:TRAIT_ANX] + _b[trait8:TRAIT_ANX] + ///
_b[trait9:TRAIT_ANX] + _b[trait15:TRAIT_ANX] + ///
_b[trait20:TRAIT_ANX])^2 *_b[/var(TRAIT_ANX)] / ((_b[trait2:TRAIT_ANX] + _b[trait4:TRAIT_ANX] + ///
_b[trait5:TRAIT_ANX] + _b[trait8:TRAIT_ANX] + ///
_b[trait9:TRAIT_ANX] + _b[trait15:TRAIT_ANX] + ///
_b[trait20:TRAIT_ANX])^2 *_b[/var(TRAIT_ANX)] + (_b[/var(e.trait2)] + ///
_b[/var(e.trait4)] + _b[/var(e.trait5)] + ///
_b[/var(e.trait8)] + _b[/var(e.trait9)] + ///
_b[/var(e.trait15)] + _b[/var(e.trait20)]) + 2* _b[/cov(e.trait5,e.trait15)]), noheader





sem (TRAIT_ANX -> trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
var(TRAIT_ANX@1) nolog
estat eqgof


estat framework, fitted



sem (TRAIT_ANX -> trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
nolog
nlcom (_b[trait2:TRAIT_ANX] + _b[trait4:TRAIT_ANX] + ///
_b[trait5:TRAIT_ANX] + _b[trait8:TRAIT_ANX] + ///
_b[trait9:TRAIT_ANX] + _b[trait15:TRAIT_ANX] + ///
_b[trait20:TRAIT_ANX])^2 *  _b[/var(TRAIT_ANX)] / ((_b[trait2:TRAIT_ANX] + _b[trait4:TRAIT_ANX] + ///
_b[trait5:TRAIT_ANX] + _b[trait8:TRAIT_ANX] + ///
_b[trait9:TRAIT_ANX] + _b[trait15:TRAIT_ANX] + ///
_b[trait20:TRAIT_ANX])^2 *  _b[/var(TRAIT_ANX)] + (_b[/var(e.trait2)] + ///
_b[/var(e.trait4)] + _b[/var(e.trait5)] + ///
_b[/var(e.trait8)] + _b[/var(e.trait9)] + ///
_b[/var(e.trait15)] + _b[/var(e.trait20)]))




mata

lambda = (.5035065 \ .6971751 \ .5680217 \ .5958545 \ .5370044 \ .5705945 \ .5907191)
lambda
phi = (1)
phi
errors = (.314802, .4662638, .2255151, .3337188, .5091331, .3030151, .4337075)
theta = diag(errors)
theta

sig_hat = lambda*phi*lambda' + theta
sig_hat

end


** baseline model
sem (trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), covstructure(_Ex, diagonal)

** saturated model
sem ( <- trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), nolog

scalar ll_s = e(ll)

estat framework, fitted

sem (TRAIT_ANX -> trait2 trait4 trait5 trait8 ///
trait9 trait15 trait20), ///
var(TRAIT_ANX@1) nolog nocnsreport


scalar ll_m = e(ll)


display "chi2 =" 2*(ll_s - ll_m)


** computing chi-square for the model
display -2*(-5826.5778 - -5744.0911)

